import cadquery as cq from cadquery import exporters import audio_plug import battery_holder import usb_hub import zero_holder as cpu_holder import screen_pillars import keyboard from utils import extrude_shape, punch_hole, punch_hole2 # Base for the notebook. Basically a kbd base that extends back # as much as possible # Thickness of the outer material shell_t = 3 # Size of the kbd board kbd_height = 95.5 kbd_width = 305 kbd_angle = 5 # Size of the whole object width = kbd_width + 2 * shell_t height = 159 thickness = 27 + shell_t # 27 inside # Insert Positions ti_radius = 2.35 ti_depth = 6.25 # These are placed where convenient, and are used to join the top and bottom # parts of the case. # Measured from top-left corner OUTSIDE mounting_pillar_positions = [ (6, 6), (6, 40), (120, 6), (170, 6), (width - 6, 6), (width - 6, 30), ] screen_pillars.init(mounting_pillar_positions, thickness - shell_t) # Thing to "grab" the hub so it stays in place # Distance from edge to center of USB plug usb_offset = 48 # CPU holder position from back-left corner of the case cpu_offset_x = 160 cpu_offset_y = 25 # Battery holder position from back-left corner of the case battery_offset_x = 19 battery_offset_y = 5 # Offset for the USB port from back-right corner of the case usb_offset = 48 def model(): # Create the basic shape of the case bottom. model = ( cq.Workplane("XY") .workplane(offset=thickness / 2) .tag("mid_height") # Hollow box .box(width, height, thickness) .edges("|Z") .fillet(2) .faces(">Z") .shell(-shell_t) ) # Now the basic box shape is in place, start adding things # and cutting holes. model = keyboard.add( model=model, width=width, height=height, thickness=thickness, bottom_face=">Z", # Yes >Z back_face=None, offset_x=0, offset_y=height - keyboard.kbd_height, shell_t=shell_t, ) model = usb_hub.add( model=model, width=width, height=height, thickness=thickness, bottom_face="